QM = {}

QM.name = "QuickMessage"
QM.author = "@TorbinWren"
QM.addonVersion = "1.0.0"
QM.dataVersion = 1

QM.defaultSettings = {
	message = {},
}

local channelList = {
	["Zone"] = CHAT_CHANNEL_ZONE,
	["Say"] = CHAT_CHANNEL_SAY,
	["Yell"] = CHAT_CHANNEL_YELL,
	["Emote"] = CHAT_CHANNEL_EMOTE,
	["Party"] = CHAT_CHANNEL_PARTY,
	["Guild 1"] = CHAT_CHANNEL_GUILD_1,
	["Guild 2"] = CHAT_CHANNEL_GUILD_2,
	["Guild 3"] = CHAT_CHANNEL_GUILD_3,
	["Guild 4"] = CHAT_CHANNEL_GUILD_4,
	["Guild 5"] = CHAT_CHANNEL_GUILD_5,
}

function QM.procSlash(param, channel)
	index = tonumber(param)
	if index ~= nil and index >=0 and index <= 9 then
		CHAT_SYSTEM:StartTextEntry(QM.settings.message[index].text, channel)
	else
		d(GetString(QM_SLASHHELP1))
		d(GetString(QM_SLASHHELP2))
		d(GetString(QM_SLASHHELP3))
		d(GetString(QM_SLASHHELP4))
		d(GetString(QM_SLASHHELP5))
		d(GetString(QM_SLASHHELP6))
		d(GetString(QM_SLASHHELP7))
		d(GetString(QM_SLASHHELP8))
	end
end

function QM.SlashQM(param)
	QM.procSlash(param, CHAT_CHANNEL_ZONE)
end

function QM.SlashQMSay(param)
	QM.procSlash(param, CHAT_CHANNEL_SAY)
end

function QM.SlashQMYell(param)
	QM.procSlash(param, CHAT_CHANNEL_YELL)
end

function QM.SlashQMEmote(param)
	QM.procSlash(param, CHAT_CHANNEL_EMOTE)
end

function QM.SlashQMParty(param)
	QM.procSlash(param, CHAT_CHANNEL_PARTY)
end

function QM.SlashQMGuild1(param)
	QM.procSlash(param, CHAT_CHANNEL_GUILD_1)
end

function QM.SlashQMGuild2(param)
	QM.procSlash(param, CHAT_CHANNEL_GUILD_2)
end

function QM.SlashQMGuild3(param)
	QM.procSlash(param, CHAT_CHANNEL_GUILD_3)
end

function QM.SlashQMGuild4(param)
	QM.procSlash(param, CHAT_CHANNEL_GUILD_4)
end

function QM.SlashQMGuild5(param)
	QM.procSlash(param, CHAT_CHANNEL_GUILD_5)
end

function QM.SlashQM0(param)
	QM.procSlash(0, channelList[QM.settings.message[0].channel])
end

function QM.SlashQM1(param)
	QM.procSlash(1, channelList[QM.settings.message[1].channel])
end

function QM.SlashQM2(param)
	QM.procSlash(2, channelList[QM.settings.message[2].channel])
end

function QM.SlashQM3(param)
	QM.procSlash(3, channelList[QM.settings.message[3].channel])
end

function QM.SlashQM4(param)
	QM.procSlash(4, channelList[QM.settings.message[4].channel])
end

function QM.SlashQM5(param)
	QM.procSlash(5, channelList[QM.settings.message[5].channel])
end

function QM.SlashQM6(param)
	QM.procSlash(6, channelList[QM.settings.message[6].channel])
end

function QM.SlashQM7(param)
	QM.procSlash(7, channelList[QM.settings.message[7].channel])
end

function QM.SlashQM8(param)
	QM.procSlash(8, channelList[QM.settings.message[8].channel])
end

function QM.SlashQM9(param)
	QM.procSlash(9, channelList[QM.settings.message[9].channel])
end

function QM.InitializeSlashCommands()
	SLASH_COMMANDS["/qm"] = QM.SlashQM
	SLASH_COMMANDS["/qmsay"] = QM.SlashQMSay
	SLASH_COMMANDS["/qms"] = QM.SlashQMSay
	SLASH_COMMANDS["/qmyell"] = QM.SlashQMYell
	SLASH_COMMANDS["/qmy"] = QM.SlashQMYell
	SLASH_COMMANDS["/qmemote"] = QM.SlashQMEmote
	SLASH_COMMANDS["/qme"] = QM.SlashQMEmote
	SLASH_COMMANDS["/qmp"] = QM.SlashQMParty
	SLASH_COMMANDS["/qmg1"] = QM.SlashQMGuild1
	SLASH_COMMANDS["/qmg2"] = QM.SlashQMGuild2
	SLASH_COMMANDS["/qmg3"] = QM.SlashQMGuild3
	SLASH_COMMANDS["/qmg4"] = QM.SlashQMGuild4
	SLASH_COMMANDS["/qmg5"] = QM.SlashQMGuild5
	SLASH_COMMANDS["/qm0"] = QM.SlashQM0
	SLASH_COMMANDS["/qm1"] = QM.SlashQM1
	SLASH_COMMANDS["/qm2"] = QM.SlashQM2
	SLASH_COMMANDS["/qm3"] = QM.SlashQM3
	SLASH_COMMANDS["/qm4"] = QM.SlashQM4
	SLASH_COMMANDS["/qm5"] = QM.SlashQM5
	SLASH_COMMANDS["/qm6"] = QM.SlashQM6
	SLASH_COMMANDS["/qm7"] = QM.SlashQM7
	SLASH_COMMANDS["/qm8"] = QM.SlashQM8
	SLASH_COMMANDS["/qm9"] = QM.SlashQM9
end


function QM.CreateSettingsMenu()
	LAM2 = LibStub:GetLibrary("LibAddonMenu-2.0")

	local panelData = {
		type = "panel",
		name = "Quick Message",
		author = QM.author,
		version = QM.addonVersion,
	}
	LAM2:RegisterAddonPanel(QM.name, panelData)
	
	local optionsData = {}
	local index = 0
	
	local channels = {}
	for i, v in next, channelList do
		table.insert(channels, i)
	end
	table.sort(channels)
	
	index = index + 1
	optionsData[index] = {
		type = "description",
		text = GetString(QM_SETTINGS_USAGE),
	}
	
	for i = 0,9 do
		index = index + 1
		optionsData[index] = {
			type = "divider",
		}
		
		index = index + 1
		optionsData[index] = {
			type = "editbox",
			name = GetString(QM_SETTINGS_MESSAGETEXT) .. " " .. i,
			isMultiline = true,
			isExtraWide = true,
			width = "full",
			getFunc = function() return QM.settings.message[i].text end,
			setFunc = function(newValue) QM.settings.message[i].text = newValue end,
		}
		
		index = index + 1
		optionsData[index] = {
			type = "dropdown",
			name = GetString(QM_SETTINGS_MESSAGECHANNEL),
			choices = channels,
			getFunc = function() return QM.settings.message[i].channel end,
			setFunc = function(newValue) QM.settings.message[i].channel = newValue end,
		}
		
	end
	
	LAM2:RegisterOptionControls(QM.name, optionsData)
end

function QM.Initialize()
	for i=0,9 do
		QM.defaultSettings.message[i] = {channel = "Zone", text = "Quick Message"}
	end
	QM.settings = ZO_SavedVars:NewAccountWide("qmVars", QM.dataVersion, GetDisplayName(), QM.defaultSettings)
	QM.CreateSettingsMenu()
	QM.InitializeSlashCommands()
end

function QM.OnAddonLoaded(event, addonName)
	if addonName ~= QM.name then return end
	
	QM.Initialize()
	
	EVENT_MANAGER:UnregisterForEvent(QM.name, EVENT_ADD_ON_LOADED)
end
	
EVENT_MANAGER:RegisterForEvent(QM.name, EVENT_ADD_ON_LOADED, QM.OnAddonLoaded)